// Array initialisation
public class ArrayInitialisation {
  public static void main(String[] args) {

    final int NO_OF_TESTS = 5;

    // Array declaration:
    int[] testScores;  // (1) Only declaration, no array creation
    // Array creation, default initialisation and assignment:
    testScores = new int[NO_OF_TESTS];       // (2) Array length specified
    assert(testScores != null);
    assert(testScores.length == NO_OF_TESTS);
    assert(testScores[0] == 0);               // First value
    assert(testScores[NO_OF_TESTS - 1] == 0); // Last value
    // and the other elements are also initialised to the default value 0.

    // Combined (1) and (2).
    // Array declration, creation, default initialisation and assignment:
    int[] testScoresII = new int[NO_OF_TESTS];

    // Array declaration:
    int[] testScoresIII;  // (3) Only declaration, no array creation
    // Array creation, explicit initialisation and assignment:
    testScoresIII = new int[] {47, 55, 58, 41, 52}; // (4) Anonymous array
    assert(testScoresIII.length == NO_OF_TESTS);
    assert(testScoresIII[0] == 47);              // First value
    assert(testScoresIII[NO_OF_TESTS -1] == 52); // Last value
    // and the other elements are also explicitly initialised accordingly.

    // Combined (3) and (4)
    // Array declaration, creation, explicit initialisation
    // and assignment:
    int[] testScoresIV = new int[] {47, 55, 58, 41, 52};
    int[] testScoresV = {47, 55, 58, 41, 52}; // Simplified form
//  testScoresV = {47, 55, 58, 41, 52};       // Compile time error!

    System.out.println(testScoresV[NO_OF_TESTS]); // Out-of-bounds error
  }
}