class EmployeeV4 {           // Assume that no constructors are declared.

  // (1) Static variables:
  static final boolean MALE = false;
  static final boolean FEMALE = true;
  static final double NORMAL_WORKWEEK = 37.5;
  static int numOfFemales;
  static int numOfMales;

  // (2) Static methods:
  // Register an employee's gender by updating the relevant counter.
  static void registerGender(boolean gender) {
    if (gender == FEMALE) {
      ++numOfFemales;
    } else {
      ++numOfMales;
    }
  }
  // Print statistics about the number of males and females registered.
  static void printStatistics() {
    System.out.println("Number of females registered: " +
                        EmployeeV4.numOfFemales);                  // (3)
    System.out.println("Number of males registered: " +
                        EmployeeV4.numOfMales);                    // (4)
  }

  // Rest of the specification is the same as in class EmployeeV3

  // Field variables
  String firstName;
  String lastName;
  double hourlyRate;
  boolean gender; // false means male, true means female

  // Instance methods

  // Assigns values to the field variables of an employee.
  void setState(String fName, String lName,
                double hRate, boolean gender) {
    this.firstName = fName;
    this.lastName = lName;
    this.hourlyRate = hRate;
    this.gender = gender;
  }

  // Determines whether an employee is a female.
  boolean isFemale() { return gender; }

  // Computes the salary of an employee, based on the number of hours
  // worked during the week.
  double computeSalary(double numOfHours) {
    assert numOfHours >= 0 : "Number of hours must be >= 0";
    double weeklySalary = hourlyRate * this.NORMAL_WORKWEEK;
    if (numOfHours > EmployeeV4.NORMAL_WORKWEEK) {
      weeklySalary += 2.0 * hourlyRate * (numOfHours - NORMAL_WORKWEEK);
    }
    return weeklySalary;
  }

  // Prints the values in the field variables of an employee.
  void printState() {
    System.out.print("First name: " + firstName);
    System.out.print("\tLast name: " + lastName);
    System.out.printf("\tHourly rate: %.2f", hourlyRate);
    if (isFemale()) {
      System.out.println("\tGender: Female");
    } else {
      System.out.println("\tGender: Male");
    }
  }
}