// An enum client
public class Weekdays {
  public static void main(String[] args) {

    Weekday lateOpeningDay = Weekday.THURSDAY;  // Reference of enum type

    // Method toString() applied implicitly
    System.out.println(lateOpeningDay);         // Prints THURSDAY.
    System.out.println(Weekday.SUNDAY);         // Prints SUNDAY.

    // Testing for equality
    assert(lateOpeningDay != Weekday.SUNDAY);   // true
    assert(lateOpeningDay == Weekday.THURSDAY); // true

    // Iterate over days of the week:
    System.out.println("Days of the week:");
    Weekday[] daysArray = Weekday.values();
    for (Weekday day : daysArray) {
      switch(day) {                             // (1)
        case SATURDAY: case SUNDAY:
          System.out.println("The day is " + day +
                             ", it must be weekend.");
          break;
        default:
          System.out.println(day + " is a working day.");
      }
    }
  }
}