// File: Employee.java
class Employee {
  static final double STANDARD_HOURLY_RATE = 15.50;
  static final double NORMAL_WORKWEEK = 37.5;
  static final double OVERTIME_COMPENSATION_PERCENTAGE = 200.0;
  static final double OVERTIME_COMPENSATION_FACTOR =
    OVERTIME_COMPENSATION_PERCENTAGE / 100.0;


  String firstName;
  String lastName;
  double hourlyRate;
  Gender gender;
  Employee manager;

  Employee(String fName, String lName, double hRate, Gender gender) {
    this.firstName = fName;
    this.lastName = lName;
    this.hourlyRate = hRate;
    this.gender = gender;
  }

  double overtimeHourlyRate() {
    return hourlyRate * OVERTIME_COMPENSATION_FACTOR;
  }

  double overtimeHours(double hoursWorkedDuringAWeek) {
    assert hoursWorkedDuringAWeek >= 0 : "Number of hours must be >= 0";
    double overtime = hoursWorkedDuringAWeek - NORMAL_WORKWEEK;

    if (overtime < 0) {
      return 0;
    }

    return overtime;
  }

  double computeSalary(double hoursWorkedDuringAWeek) {
    return NORMAL_WORKWEEK * hourlyRate
      + overtimeHours(hoursWorkedDuringAWeek) * overtimeHourlyRate();
  }
}
