// A simple CD class that can be ordered by title and # of tracks.
class CD implements Comparable {
  // Declaration of field variables
  String title;
  int    noOfTracks;

  // Creates a new CD with given title and # of tracks.
  CD(String title, int noOfTracks) {
    this.title = title;
    this.noOfTracks = noOfTracks;
  }

  // Prepares a string representation of the CD.
  public String toString () {
    return "The CD entitled '" + title + "' has " + noOfTracks + " tracks.";
  }

  // Compares two CDs. Returns 0 if they are equal, i.e. have the same
  // title and number of tracks, < 0 if the first title is smaller 
  // (lexicographically) than the second title, and > 0 otherwise.
  public int compareTo(Object obj) {
    CD otherCD = (CD) obj;
    if (title.equals(otherCD.title)) {
      return noOfTracks - otherCD.noOfTracks;
    } else {
      return title.compareTo(otherCD.title);
    }
  }
}