// Time is given as hours (0-23) and minutes (0-59).
class Time implements Comparable {        // (1)

  // Fields for the time.
  int hours;
  int minutes;

  /** Constructor */
  Time(int hours, int minutes) {
    assert (0 <= hours && hours <= 23 && 0 <= minutes && minutes <= 59) :
            "Invalid hours and/or minutes";
    this.hours = hours;
    this.minutes = minutes;
  }

  /** String representation of the time, TT:MM */
  public String toString() {
    return String.format("%02d:%02d", hours, minutes);
  }

  /** Comparing Time objects */
  public int compareTo(Object obj2) {    // (2)
    Time t2 = (Time) obj2;               // (3) Cast required, as we are
                                         //     comparing Time objects
    // Check if the hours are different
    if (this.hours != t2.hours) {
      // Order is determined by which of the hours is greater
      return this.hours - t2.hours;
    }
    // Have the same hours. Check if the minutes are different.
    if (this.minutes != t2.minutes) {
      // Order is determined by which of the minutes is greater
      return this.minutes - t2.minutes;
    }
    // Both hours and minutes have the same values.
    return 0;                           // Objects represent the same time
  }
}